/*
This shows an example for creating an LMM program and Makefile.
It simply toggles the pins at 1Hz rate.

Copyright (c) 2011 Parallax, Inc.
MIT Licensed.

+--------------------------------------------------------------------
¦  TERMS OF USE: MIT License
+--------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+--------------------------------------------------------------------
*/

#include "propeller.h"


int main(int argc, char* argv[])
{
#if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC)
    int mask = 0x00008000;  /* only toggle the C3 board LED */
#else
    int mask = 0x3fffffff;  /* toggle all pins except the serial */
#endif
    int freq;

    freq = CLKFREQ;

    DIRA = mask;
    OUTA = mask;
    for(;;) {
        OUTA ^= mask;
        waitcnt(freq+CNT);
    }    
}
